*!* Program: ClassBuilder.PRG
*!* Author: Tamar E. Granor
*!* Date: 03/28/03 11:13:53 AM
*!* Copyright: 2003, Tamar E. Granor
*!* Description: Code for a Toolbox script for a "class builder"
*!*              that provides a jump start to creating coded classes
*!* Revision Information:
*!*    08/15/2007 Added support for VFP baseclasses

PRIVATE cClassDef

* DO FORM ClassBuilder TO cClassDef

cClassDef = ""
oForm = CREATEOBJECT("frmClassbuilder","cClassDef")

* Create font handler to bump fonts
IF VARTYPE(glIsDemo)="L" AND glIsDemo
	oFontHandler = NEWOBJECT("cusFontHandler","accessibility")
	ofonthandler.changefont(oForm,.t.)
ENDIF 

oForm.AutoCenter = .t.
oForm.Show()

* Pause briefly to let VFP catch up
WAIT "" TIMEOUT 0.1

RETURN cClassDef

**************************************************
*-- Form:         frmclassbuilder (d:\writing\confs\swfox\swfox2007\toolbox\examples\classbuilder.scx)
*-- ParentClass:  form
*-- BaseClass:    form
*-- Time Stamp:   08/15/07 03:56:09 PM
*
DEFINE CLASS frmclassbuilder AS form


	Top = 0
	Left = 0
	Height = 427
	Width = 777
	DoCreate = .T.
	Caption = "Class Builder"
	WindowType = 1
	*-- Name of the class to create
	cclassname = ("")
	*-- Name of the parent class
	cparentclass = ("")
	*-- Classs library for parent class
	cparentclasslib = ("")
	*-- Number of new properties
	nnewpropcount = 0
	*-- The position of the item currently being edited
	nedititem = 0
	*-- Number of new methods
	nnewmethodcount = 0
	*-- The string to return from the form
	cresult = ("")
	*-- Variable in which to store resulting code
	cresultvar = ("")
	*-- XML Metadata for customizable properties
	_memberdata = [<VFPData><memberdata name="abaseclasses" type="property" display="aBaseClasses"/><memberdata name="cbaseclass" type="property" display="cBaseClass"/></VFPData>]
	cbaseclass = ""
	Name = "frmclassbuilder"

	*-- List of custom properties to add to class
	DIMENSION acustomprops[1,2]

	*-- List of custom methods to add
	DIMENSION acustommethods[1]
	DIMENSION abaseclasses[1]


	ADD OBJECT shape1 AS shape WITH ;
		Top = 116, ;
		Left = 16, ;
		Height = 279, ;
		Width = 360, ;
		Name = "Shape1"


	ADD OBJECT shape2 AS shape WITH ;
		Top = 115, ;
		Left = 392, ;
		Height = 279, ;
		Width = 360, ;
		Name = "Shape2"


	ADD OBJECT lblclassname AS label WITH ;
		Caption = "\<Class name", ;
		Height = 17, ;
		Left = 12, ;
		Top = 27, ;
		Width = 100, ;
		TabIndex = 1, ;
		Name = "lblClassName"


	ADD OBJECT lblparentclass AS label WITH ;
		Caption = "\<Parent class", ;
		Height = 17, ;
		Left = 12, ;
		Top = 51, ;
		Width = 100, ;
		TabIndex = 3, ;
		Name = "lblParentClass"


	ADD OBJECT txtclassname AS textbox WITH ;
		ControlSource = "ThisForm.cClassName", ;
		Height = 23, ;
		Left = 120, ;
		TabIndex = 2, ;
		Top = 24, ;
		Width = 261, ;
		Name = "txtClassName"


	ADD OBJECT txtparentclass AS textbox WITH ;
		ControlSource = "ThisForm.cParentClass", ;
		Height = 23, ;
		Left = 120, ;
		ReadOnly = .T., ;
		TabIndex = 4, ;
		Top = 48, ;
		Width = 261, ;
		Name = "txtParentClass"


	ADD OBJECT txtparentclasslib AS textbox WITH ;
		ControlSource = "ThisForm.cParentClassLib", ;
		Height = 23, ;
		Left = 120, ;
		ReadOnly = .T., ;
		TabIndex = 6, ;
		Top = 72, ;
		Width = 261, ;
		Name = "txtParentClassLib"


	ADD OBJECT cmdgetparentclass AS commandbutton WITH ;
		Top = 47, ;
		Left = 389, ;
		Height = 27, ;
		Width = 30, ;
		Caption = "...", ;
		TabIndex = 5, ;
		Name = "cmdGetParentClass"


	ADD OBJECT lblcustomprops AS label WITH ;
		AutoSize = .T., ;
		Caption = "Custom Properties", ;
		Height = 17, ;
		Left = 28, ;
		Top = 108, ;
		Width = 106, ;
		TabIndex = 7, ;
		Name = "lblCustomProps"


	ADD OBJECT txtnewprop AS textbox WITH ;
		Height = 23, ;
		Left = 97, ;
		TabIndex = 9, ;
		Top = 134, ;
		Width = 171, ;
		Name = "txtNewProp"


	ADD OBJECT cmdaddprop AS commandbutton WITH ;
		Top = 132, ;
		Left = 277, ;
		Height = 27, ;
		Width = 84, ;
		Caption = "\<Add", ;
		TabIndex = 12, ;
		Name = "cmdAddProp"


	ADD OBJECT lstcustomprops AS listbox WITH ;
		ColumnCount = 2, ;
		ColumnWidths = "100,50", ;
		RowSourceType = 5, ;
		RowSource = "thisform.acustomprops", ;
		Height = 170, ;
		Left = 28, ;
		TabIndex = 13, ;
		Top = 207, ;
		Width = 168, ;
		Name = "lstCustomProps"


	ADD OBJECT txtinitialvalue AS textbox WITH ;
		Height = 23, ;
		Left = 97, ;
		TabIndex = 11, ;
		Top = 168, ;
		Width = 171, ;
		Name = "txtInitialValue"


	ADD OBJECT cmdeditprop AS commandbutton WITH ;
		Top = 207, ;
		Left = 222, ;
		Height = 27, ;
		Width = 84, ;
		Caption = "\<Edit", ;
		TabIndex = 14, ;
		Name = "cmdEditProp"


	ADD OBJECT lblproperty AS label WITH ;
		AutoSize = .T., ;
		Caption = "P\<roperty", ;
		Height = 17, ;
		Left = 31, ;
		Top = 137, ;
		Width = 47, ;
		TabIndex = 8, ;
		Name = "lblProperty"


	ADD OBJECT lblinitialvalue AS label WITH ;
		AutoSize = .T., ;
		Caption = "\<Initial value", ;
		Height = 17, ;
		Left = 31, ;
		Top = 171, ;
		Width = 63, ;
		TabIndex = 10, ;
		Name = "lblInitialValue"


	ADD OBJECT lblcustommethods AS label WITH ;
		AutoSize = .T., ;
		Caption = "Custom Methods", ;
		Height = 17, ;
		Left = 403, ;
		Top = 109, ;
		Width = 96, ;
		TabIndex = 15, ;
		Name = "lblCustomMethods"


	ADD OBJECT txtnewmethod AS textbox WITH ;
		Height = 23, ;
		Left = 456, ;
		TabIndex = 17, ;
		Top = 135, ;
		Width = 171, ;
		Name = "txtNewMethod"


	ADD OBJECT cmdaddmethod AS commandbutton WITH ;
		Top = 133, ;
		Left = 650, ;
		Height = 27, ;
		Width = 84, ;
		Caption = "A\<dd", ;
		TabIndex = 18, ;
		Name = "cmdAddMethod"


	ADD OBJECT lstcustommethods AS listbox WITH ;
		RowSourceType = 5, ;
		RowSource = "thisform.acustommethods", ;
		Height = 170, ;
		Left = 407, ;
		TabIndex = 19, ;
		Top = 207, ;
		Width = 168, ;
		Name = "lstCustomMethods"


	ADD OBJECT cmdeditmethod AS commandbutton WITH ;
		Top = 207, ;
		Left = 601, ;
		Height = 27, ;
		Width = 84, ;
		Caption = "Edi\<t", ;
		TabIndex = 20, ;
		Name = "cmdEditMethod"


	ADD OBJECT lblmethod AS label WITH ;
		AutoSize = .T., ;
		Caption = "\<Method", ;
		Height = 17, ;
		Left = 404, ;
		Top = 138, ;
		Width = 42, ;
		TabIndex = 16, ;
		Name = "lblMethod"


	ADD OBJECT cmdbuild AS commandbutton WITH ;
		Top = 24, ;
		Left = 660, ;
		Height = 27, ;
		Width = 84, ;
		Caption = "\<Build", ;
		TabIndex = 21, ;
		Name = "cmdBuild"


	ADD OBJECT cmdcancel AS commandbutton WITH ;
		Top = 60, ;
		Left = 660, ;
		Height = 27, ;
		Width = 84, ;
		Cancel = .T., ;
		Caption = "Cancel", ;
		TabIndex = 22, ;
		Name = "cmdCancel"


	ADD OBJECT cbobaseclasses AS combobox WITH ;
		RowSourceType = 5, ;
		RowSource = "ThisForm.aBaseClasses", ;
		ControlSource = "ThisForm.cBaseClass", ;
		Height = 24, ;
		Left = 512, ;
		Top = 47, ;
		Width = 130, ;
		Name = "cboBaseClasses"


	ADD OBJECT label1 AS label WITH ;
		AutoSize = .T., ;
		Caption = "\<Base class", ;
		Height = 17, ;
		Left = 436, ;
		Top = 51, ;
		Width = 64, ;
		TabIndex = 3, ;
		Name = "Label1"


	*-- Create the code for the class
	PROCEDURE generateclasscode
		* Use the input to create a code class.
		#DEFINE CRLF CHR(13) + CHR(10)

		* First, check that all required elements are present.
		IF EMPTY(This.cClassName) OR ;
		   ((EMPTY(This.cParentClass) OR ;
		   EMPTY(This.cParentClassLib)) AND ;
		    EMPTY(This.cBaseClass))
		   
		   RETURN
		ENDIF

		* Good to go
		LOCAL cClassDef, cPropList, cMethodList, nItem

		* Build list of properties
		cPropList = ""
		FOR nItem = 1 TO This.nNewPropCount
			cPropList = cPropList + CRLF + ALLTRIM(This.aCustomProps[ nItem, 1]) + ;
			            " = " + ;
			            TRANSFORM(This.aCustomProps[ nItem, 2])
		ENDFOR

		cMethodList = ""
		FOR nItem = 1 TO This.nNewMethodCount
			cMethodList = cMethodList + CRLF + "PROCEDURE " + ;
			              ALLTRIM(This.aCustomMethods[nItem]) + CRLF + ;
			              CRLF + "RETURN" + CRLF + "ENDPROC" + CRLF
		ENDFOR

		* Based on existing class or on base class?
		IF EMPTY(This.cBaseClass)
			cClassInfo = TEXTMERGE("<<ALLTRIM(This.cParentClass)>> FROM <<ALLTRIM(This.cParentClassLib)>>")
		ELSE
			cClassInfo = TEXTMERGE("<<ALLTRIM(This.cBaseClass)>>")
		ENDIF 

		TEXT TO cClassDef TEXTMERGE NOSHOW
DEFINE CLASS <<ALLTRIM(This.cClassname)>> AS <<cClassInfo>>

<<cPropList>>

<<cMethodList>>

ENDDEFINE 
		ENDTEXT

		This.cResult = cClassDef

		RETURN
	ENDPROC


	*-- Enable and disable controls based on current status
	PROCEDURE enablecontrols
		* Enable and disable controls

		IF EMPTY(This.cclassname) OR ;
		   (EMPTY(This.cParentClass) AND ;
		   EMPTY(This.cBaseClass))
		   
		   This.txtNewProp.Enabled = .f.
		   This.txtInitialValue.Enabled= .f.
		   This.txtNewMethod.Enabled = .f.
		   This.cmdAddProp.Enabled=.f.
		   This.cmdeditProp.Enabled=.f.
		   This.cmdAddMethod.Enabled = .f.
		   This.cmdEditMethod.Enabled=.f.
		   This.lstCustomProps.Enabled=.f.
		   This.lstCustomMethods.Enabled=.f.
		   This.cmdBuild.Enabled=.f.

		ELSE

		   This.txtNewProp.Enabled = .t.
		   This.txtInitialValue.Enabled= .t.
		   This.txtNewMethod.Enabled = .t.
		   This.cmdAddProp.Enabled=.t.
		   This.cmdAddMethod.Enabled = .t.
		   This.cmdBuild.Enabled=.t.

		   IF This.nNewPropCount=0
		      This.cmdEditProp.Enabled=.f.
		      This.lstCustomProps.Enabled=.f.
		   ELSE 
		      This.cmdeditProp.Enabled=.t.
		      This.lstCustomProps.Enabled=.t.
		   ENDIF 

		   IF This.nNewMethodCount=0
		      This.cmdEditMethod.Enabled=.f.
		      This.lstCustomMethods.Enabled=.f.
		   ELSE
		      This.cmdEditMethod.Enabled=.t.
		      This.lstCustomMethods.Enabled=.t.
		   ENDIF
		ENDIF

		RETURN 
	ENDPROC


	PROCEDURE Unload
		IF NOT EMPTY(This.cResultVar)
		   STORE This.cResult TO (This.cResultVar)
		ENDIF 

		RETURN This.cResult
	ENDPROC


	PROCEDURE Init
		LPARAMETERS tcResult

		IF VARTYPE(tcResult)="C"
			This.cResultVar = tcResult
		ELSE
			This.cResultVar = ""
		ENDIF


		ThisForm.aCustomProps[1,1] = ""
		ThisForm.aCustomProps[1,2] = ""
		ThisForm.aCustomMethods[1] = ""

		This.EnableControls()

		RETURN
	ENDPROC


	PROCEDURE txtclassname.Valid
		ThisForm.EnableControls()

		RETURN
	ENDPROC


	PROCEDURE cmdgetparentclass.Click
		LOCAL aParentClass[1]

		IF AGETCLASS( aParentClass )
			ThisForm.cParentclass = aParentClass[2]
			ThisForm.cParentclasslib = aParentClass[1]
			ThisForm.Refresh()
		ENDIF

		ThisForm.EnableControls()

		RETURN
	ENDPROC


	PROCEDURE cmdaddprop.Click
		* Check for values needed
		IF EMPTY(ThisForm.txtNewProp.Value) OR ;
		   EMPTY(ThisForm.txtInitialValue.Value)
		   
		   RETURN
		ENDIF

		* New addition or resave
		IF "Add" $ This.Caption
			ThisForm.nNewPropCount = ThisForm.nNewPropCount + 1
			DIMENSION Thisform.aCustomprops[ ThisForm.nNewPropcount, 2]
			ThisForm.aCustomprops[ThisForm.nNewPropcount, 1] = ThisForm.txtNewProp.Value
			ThisForm.aCustomprops[ThisForm.nNewPropcount, 2] = ThisForm.txtInitialValue.Value
		ELSE
			* Resaving existing item
			ThisForm.aCustomProps[ ThisForm.nEditItem, 1] = ThisForm.txtNewProp.Value
			ThisForm.aCustomProps[ ThisForm.nEditItem, 2] = ThisForm.txtInitialValue.Value
			This.Caption = "Add"
		ENDIF

		ThisForm.lstCustomProps.Requery()
		ThisForm.txtNewProp.Value = ""
		ThisForm.txtInitialValue.Value = ""
		ThisForm.Refresh()
		ThisForm.txtNewProp.SetFocus()

		ThisForm.EnableControls()

		RETURN
	ENDPROC


	PROCEDURE cmdeditprop.Click
		* Edit current list item
		IF ThisForm.lstCustomProps.ListIndex=0
			RETURN
		ENDIF

		ThisForm.nEditItem = ThisForm.lstCustomProps.ListIndex
		ThisForm.txtNewProp.Value = ThisForm.lstCustomProps.List[ ThisForm.lstCustomProps.ListIndex,1]
		ThisForm.txtInitialValue.Value = ThisForm.lstCustomProps.List[ ThisForm.lstCustomProps.ListIndex,2]

		ThisForm.cmdAddProp.Caption="Save"

		ThisForm.txtnewProp.SetFocus()

		ThisForm.EnableControls()

		RETURN
	ENDPROC


	PROCEDURE cmdaddmethod.Click
		* Check for values needed
		IF EMPTY(ThisForm.txtNewMethod.Value)    
		   RETURN
		ENDIF

		* New addition or resave
		IF "Add" $ STRTRAN(This.Caption, "\<", "")

			ThisForm.nNewMethodCount = ThisForm.nNewMethodCount + 1
			DIMENSION Thisform.aCustomMethods[ ThisForm.nNewMethodcount]
			ThisForm.aCustomMethods[ThisForm.nNewMethodcount] = ThisForm.txtNewMethod.Value
		ELSE
			* Resaving existing item
			ThisForm.aCustomMethods[ ThisForm.nEditItem] = ThisForm.txtNewMethod.Value
			This.Caption = "Add"
		ENDIF

		ThisForm.lstCustomMethods.Requery()
		ThisForm.txtNewMethod.Value = ""
		ThisForm.Refresh()
		ThisForm.txtNewMethod.SetFocus()

		ThisForm.EnableControls()

		RETURN
	ENDPROC


	PROCEDURE cmdeditmethod.Click
		* Edit current list item
		IF ThisForm.lstCustomMethods.ListIndex=0
			RETURN
		ENDIF

		ThisForm.nEditItem = ThisForm.lstCustomMethods.ListIndex
		ThisForm.txtNewMethod.Value = ThisForm.lstCustomMethods.List[ ThisForm.lstCustomMethods.ListIndex,1]

		ThisForm.cmdAddMethod.Caption="Save"

		ThisForm.txtNewMethod.SetFocus()

		ThisForm.EnableControls()

		RETURN
	ENDPROC


	PROCEDURE cmdbuild.Click
		ThisForm.GenerateClassCode()

		IF NOT EMPTY(ThisForm.cResult)
			ThisForm.Release()
		ENDIF

		RETURN
	ENDPROC


	PROCEDURE cmdcancel.Click
		ThisForm.Release()
	ENDPROC


	PROCEDURE cbobaseclasses.Init
		LOCAL aClassList[1], nClass, nClassCount, nDelCount

		nClassCount = ALANGUAGE(aClassList, 3)

		* Remove classes you can't subclass
		nDelCount = 0
		nClass = ASCAN(aClassList, "ActiveDoc")
		IF nClass <> 0
			ADEL(aClassList, nClass)
			nDelCount = nDelCount + 1 
		ENDIF

		nClass = ASCAN(aClassList, "Empty")
		IF nClass <> 0
			ADEL(aClassList, nClass)
			nDelCount = nDelCount + 1 
		ENDIF
		DIMENSION aClassList[nClassCount - nDelCount]

		ACOPY(aClassList, ThisForm.aBaseClasses)
		This.Requery()
	ENDPROC


	PROCEDURE cbobaseclasses.Valid
		ThisForm.EnableControls()
	ENDPROC


ENDDEFINE
*
*-- EndDefine: frmclassbuilder
**************************************************
